## toml11 4.0.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)
project(toml11 LANGUAGES CXX VERSION 4.0.0)

include(CMakeDependentOption)
include(CTest)

option(TOML11_PRECOMPILE "precompile toml11 library" OFF)

cmake_dependent_option(TOML11_INSTALL "install toml11 library" ON
    "${CMAKE_PROJECT_NAME} STREQUAL ${PROJECT_NAME}" OFF)
cmake_dependent_option(TOML11_BUILD_EXAMPLES "build toml11 examples" OFF
    "${CMAKE_PROJECT_NAME} STREQUAL ${PROJECT_NAME}" OFF)
cmake_dependent_option(TOML11_BUILD_TESTS "build toml11 unit tests" OFF
    "${CMAKE_PROJECT_NAME} STREQUAL ${PROJECT_NAME}; ${BUILD_TESTING}" OFF)
cmake_dependent_option(TOML11_BUILD_TOML_TESTS "build toml11 toml-test encoder & decoder" OFF
    "${CMAKE_PROJECT_NAME} STREQUAL ${PROJECT_NAME}" OFF)
cmake_dependent_option(TOML11_TEST_WITH_ASAN  "build toml11 unit tests with asan" OFF
    "${TOML11_BUILD_TESTS}" OFF)
cmake_dependent_option(TOML11_TEST_WITH_UBSAN "build toml11 unit tests with ubsan" OFF
    "${TOML11_BUILD_TESTS}" OFF)

if(${TOML11_TEST_WITH_ASAN} AND ${TOML11_TEST_WITH_UBSAN})
    message(FATAL_ERROR "trying to build tests with BOTH asan and ubsan")
endif()

include(GNUInstallDirs)

set(TOML11_INSTALL_CMAKE_DIR   ${CMAKE_INSTALL_LIBDIR}/cmake/toml11)
set(TOML11_INSTALL_INCLUDE_DIR ${CMAKE_INSTALL_INCLUDEDIR})
set(TOML11_CONFIG_DIR          ${CMAKE_CURRENT_BINARY_DIR}/cmake)
set(TOML11_CONFIG              ${TOML11_CONFIG_DIR}/toml11Config.cmake)
set(TOML11_CONFIG_VERSION      ${TOML11_CONFIG_DIR}/toml11ConfigVersion.cmake)

# root project?
if(${CMAKE_PROJECT_NAME} STREQUAL ${PROJECT_NAME})
    if(NOT DEFINED CMAKE_CXX_STANDARD)
        set(CMAKE_CXX_STANDARD 11)
    endif()
    if(NOT DEFINED CMAKE_CXX_EXTENSIONS)
        set(CMAKE_CXX_EXTENSIONS OFF)
    endif()
    if(NOT DEFINED CMAKE_CXX_STANDARD_REQUIRED)
        set(CMAKE_CXX_STANDARD_REQUIRED ON)
    endif()

    if(${TOML11_BUILD_TESTS} OR ${TOML11_BUILD_TOML_TESTS})
        add_subdirectory(tests)
    endif()

    if(${TOML11_BUILD_EXAMPLES})
        add_subdirectory(examples)
    endif()
endif()

add_subdirectory(src)

=== examples/CMakeLists.txt ===
add_subdirectory(boost_container)
add_subdirectory(boost_multiprecision)
add_subdirectory(parse_file)
add_subdirectory(reflect)
add_subdirectory(unicode)

=== src/CMakeLists.txt ===
set(TOML11_FWD_HEADERS
    ${PROJECT_SOURCE_DIR}/include/toml11/fwd/color_fwd.hpp
    ${PROJECT_SOURCE_DIR}/include/toml11/fwd/comments_fwd.hpp
    ${PROJECT_SOURCE_DIR}/include/toml11/fwd/datetime_fwd.hpp
    ${PROJECT_SOURCE_DIR}/include/toml11/fwd/error_info_fwd.hpp
    ${PROJECT_SOURCE_DIR}/include/toml11/fwd/format_fwd.hpp
    ${PROJECT_SOURCE_DIR}/include/toml11/fwd/literal_fwd.hpp
    ${PROJECT_SOURCE_DIR}/include/toml11/fwd/location_fwd.hpp
    ${PROJECT_SOURCE_DIR}/include/toml11/fwd/region_fwd.hpp
    ${PROJECT_SOURCE_DIR}/include/toml11/fwd/scanner_fwd.hpp
    ${PROJECT_SOURCE_DIR}/include/toml11/fwd/source_location_fwd.hpp
    ${PROJECT_SOURCE_DIR}/include/toml11/fwd/syntax_fwd.hpp
    ${PROJECT_SOURCE_DIR}/include/toml11/fwd/value_t_fwd.hpp
    )
set(TOML11_IMPL_HEADERS
    ${PROJECT_SOURCE_DIR}/include/toml11/impl/color_impl.hpp
    ${PROJECT_SOURCE_DIR}/include/toml11/impl/comments_impl.hpp
    ${PROJECT_SOURCE_DIR}/include/toml11/impl/datetime_impl.hpp
    ${PROJECT_SOURCE_DIR}/include/toml11/impl/error_info_impl.hpp
    ${PROJECT_SOURCE_DIR}/include/toml11/impl/format_impl.hpp
    ${PROJECT_SOURCE_DIR}/include/toml11/impl/literal_impl.hpp
    ${PROJECT_SOURCE_DIR}/include/toml11/impl/location_impl.hpp
    ${PROJECT_SOURCE_DIR}/include/toml11/impl/region_impl.hpp
    ${PROJECT_SOURCE_DIR}/include/toml11/impl/scanner_impl.hpp
    ${PROJECT_SOURCE_DIR}/include/toml11/impl/source_location_impl.hpp
    ${PROJECT_SOURCE_DIR}/include/toml11/impl/syntax_impl.hpp
    ${PROJECT_SOURCE_DIR}/include/toml11/impl/value_t_impl.hpp
    )
set(TOML11_MAIN_HEADERS
    ${PROJECT_SOURCE_DIR}/include/toml11/color.hpp
    ${PROJECT_SOURCE_DIR}/include/toml11/comments.hpp
    ${PROJECT_SOURCE_DIR}/include/toml11/compat.hpp
    ${PROJECT_SOURCE_DIR}/include/toml11/context.hpp
    ${PROJECT_SOURCE_DIR}/include/toml11/conversion.hpp
    ${PROJECT_SOURCE_DIR}/include/toml11/datetime.hpp
    ${PROJECT_SOURCE_DIR}/include/toml11/error_info.hpp
    ${PROJECT_SOURCE_DIR}/include/toml11/exception.hpp
    ${PROJECT_SOURCE_DIR}/include/toml11/find.hpp
    ${PROJECT_SOURCE_DIR}/include/toml11/format.hpp
    ${PROJECT_SOURCE_DIR}/include/toml11/from.hpp
    ${PROJECT_SOURCE_DIR}/include/toml11/get.hpp
    ${PROJECT_SOURCE_DIR}/include/toml11/into.hpp
    ${PROJECT_SOURCE_DIR}/include/toml11/literal.hpp
    ${PROJECT_SOURCE_DIR}/include/toml11/location.hpp
    ${PROJECT_SOURCE_DIR}/include/toml11/ordered_map.hpp
    ${PROJECT_SOURCE_DIR}/include/toml11/parser.hpp
    ${PROJECT_SOURCE_DIR}/include/toml11/region.hpp
    ${PROJECT_SOURCE_DIR}/include/toml11/result.hpp
    ${PROJECT_SOURCE_DIR}/include/toml11/scanner.hpp
    ${PROJECT_SOURCE_DIR}/include/toml11/serializer.hpp
    ${PROJECT_SOURCE_DIR}/include/toml11/skip.hpp
    ${PROJECT_SOURCE_DIR}/include/toml11/source_location.hpp
    ${PROJECT_SOURCE_DIR}/include/toml11/spec.hpp
    ${PROJECT_SOURCE_DIR}/include/toml11/storage.hpp
    ${PROJECT_SOURCE_DIR}/include/toml11/syntax.hpp
    ${PROJECT_SOURCE_DIR}/include/toml11/traits.hpp
    ${PROJECT_SOURCE_DIR}/include/toml11/types.hpp
    ${PROJECT_SOURCE_DIR}/include/toml11/utility.hpp
    ${PROJECT_SOURCE_DIR}/include/toml11/value.hpp
    ${PROJECT_SOURCE_DIR}/include/toml11/value_t.hpp
    ${PROJECT_SOURCE_DIR}/include/toml11/version.hpp
    ${PROJECT_SOURCE_DIR}/include/toml11/visit.hpp
    )

set(TOML11_ROOT_HEADER
    ${PROJECT_SOURCE_DIR}/include/toml.hpp
    )

if(TOML11_PRECOMPILE)
    add_library(toml11
        ${TOML11_FWD_HEADERS}
        ${TOML11_IMPL_HEADERS}
        ${TOML11_MAIN_HEADERS}
        ${TOML11_ROOT_HEADER}
        color.cpp
        context.cpp
        comments.cpp
        datetime.cpp
        error_info.cpp
        format.cpp
        literal.cpp
        location.cpp
        parser.cpp
        region.cpp
        scanner.cpp
        serializer.cpp
        skip.cpp
        source_location.cpp
        syntax.cpp
        types.cpp
        value_t.cpp
        )
    target_compile_definitions(toml11 PUBLIC -DTOML11_COMPILE_SOURCES)
    target_include_directories(toml11 PUBLIC
        $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
        $<INSTALL_INTERFACE:include>
        )

    # required options to use toml11 with MSVC
    if(MSVC)
        target_compile_options(toml11 PUBLIC "/utf-8")
        if(MSVC_VERSION LESS 1910)
            message(STATUS "MSVC < 1910. DEFINE_CONVERSION_NON_INTRUSIVE is disabled")
            target_compile_definitions(toml11 PUBLIC -DTOML11_WITHOUT_DEFINE_NON_INTRUSIVE)
        elseif(MSVC_VERSION LESS 1920) # MSVC 2017
            target_compile_options(toml11 PUBLIC "/experimental:preprocessor")
        else() # MSVC 2019
            target_compile_options(toml11 PUBLIC "/Zc:preprocessor")
        endif()
    endif()
else()
    add_library(toml11 INTERFACE)
    target_include_directories(toml11 INTERFACE
        $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
        $<INSTALL_INTERFACE:include>
        )

    # required options to use toml11 with MSVC
    if(MSVC)
        target_compile_options(toml11 INTERFACE "/utf-8")
        if(MSVC_VERSION LESS 1910)
            message(STATUS "MSVC < 1910. DEFINE_CONVERSION_NON_INTRUSIVE is disabled")
            target_compile_definitions(toml11 PUBLIC -DTOML11_WITHOUT_DEFINE_NON_INTRUSIVE)
        elseif(MSVC_VERSION LESS 1920) # MSVC 2017
            target_compile_options(toml11 INTERFACE "/experimental:preprocessor")
        else() # MSVC 2019
            target_compile_options(toml11 INTERFACE "/Zc:preprocessor")
        endif()
    endif()
endif()


if(TOML11_INSTALL)

    include(CMakePackageConfigHelpers)
    write_basic_package_version_file(${TOML11_CONFIG_VERSION}
        VERSION ${toml11_VERSION}
        COMPATIBILITY SameMajorVersion
        )

    configure_package_config_file(
        ${PROJECT_SOURCE_DIR}/cmake/toml11Config.cmake.in
        ${TOML11_CONFIG}
        INSTALL_DESTINATION ${TOML11_INSTALL_CMAKE_DIR}
        PATH_VARS TOML11_INSTALL_CMAKE_DIR TOML11_INSTALL_INCLUDE_DIR
        )

    install(FILES ${TOML11_CONFIG} ${TOML11_CONFIG_VERSION}
        DESTINATION ${TOML11_INSTALL_CMAKE_DIR})

    install(FILES ${TOML11_ROOT_HEADER}
        DESTINATION ${TOML11_INSTALL_INCLUDE_DIR}
        )
    install(FILES ${TOML11_MAIN_HEADERS}
        DESTINATION ${TOML11_INSTALL_INCLUDE_DIR}/toml11
        )
    install(FILES ${TOML11_FWD_HEADERS}
        DESTINATION ${TOML11_INSTALL_INCLUDE_DIR}/toml11/fwd
        )

    install(FILES ${TOML11_IMPL_HEADERS}
        DESTINATION ${TOML11_INSTALL_INCLUDE_DIR}/toml11/impl
        )

    install(TARGETS toml11 EXPORT toml11Targets)
    install(EXPORT toml11Targets
        FILE toml11Targets.cmake
        DESTINATION ${TOML11_INSTALL_CMAKE_DIR}
        NAMESPACE toml11::
        )
endif()

add_library(toml11::toml11 ALIAS toml11)

=== tests/CMakeLists.txt ===
set(TOML11_TEST_NAMES
    test_comments
    test_datetime
    test_find
    test_find_or
    test_format_integer
    test_format_floating
    test_format_table
    test_get
    test_get_or
    test_location
    test_literal
    test_parse_null
    test_parse_boolean
    test_parse_integer
    test_parse_floating
    test_parse_string
    test_parse_datetime
    test_parse_array
    test_parse_inline_table
    test_parse_table_keys
    test_parse_table
    test_result
    test_scanner
    test_syntax_boolean
    test_syntax_integer
    test_syntax_floating
    test_syntax_string
    test_syntax_datetime
    test_syntax_key
    test_syntax_comment
    test_spec
    test_storage
    test_traits
    test_types
    test_utility
    test_user_defined_conversion
    test_value
    test_visit
    )

include(CheckCXXCompilerFlag)

check_cxx_compiler_flag("-Wall"      COMPILER_SUPPORTS_WALL)
check_cxx_compiler_flag("-Wextra"    COMPILER_SUPPORTS_WEXTRA)
check_cxx_compiler_flag("-Wpedantic" COMPILER_SUPPORTS_WPEDANTIC)
check_cxx_compiler_flag("-Werror"    COMPILER_SUPPORTS_WERROR)

check_cxx_compiler_flag("-Wsign-conversion"     COMPILER_SUPPORTS_WSIGN_CONVERSION)
check_cxx_compiler_flag("-Wconversion"          COMPILER_SUPPORTS_WCONVERSION)
check_cxx_compiler_flag("-Wduplicated-cond"     COMPILER_SUPPORTS_WDUPLICATED_COND)
check_cxx_compiler_flag("-Wduplicated-branches" COMPILER_SUPPORTS_WDUPLICATED_BRANCHES)
check_cxx_compiler_flag("-Wlogical-op"          COMPILER_SUPPORTS_WLOGICAL_OP)
check_cxx_compiler_flag("-Wdouble-promotion"    COMPILER_SUPPORTS_WDOUBLE_PROMOTION)
check_cxx_compiler_flag("-Wrange-loop-analysis" COMPILER_SUPPORTS_WRANGE_LOOP_ANALYSIS)
check_cxx_compiler_flag("-Wundef"               COMPILER_SUPPORTS_WUNDEF)
check_cxx_compiler_flag("-Wshadow"              COMPILER_SUPPORTS_WSHADOW)

if(BUILD_TESTING)
    add_library(toml11_test_utility STATIC utility.cpp)
    target_include_directories(toml11_test_utility
        PRIVATE ${PROJECT_SOURCE_DIR}/tests/extlib/doctest/doctest/
        )
    target_link_libraries(toml11_test_utility PUBLIC toml11)

    foreach(TEST_NAME ${TOML11_TEST_NAMES})
        add_executable(${TEST_NAME} ${TEST_NAME}.cpp)
        target_include_directories(${TEST_NAME}
            PRIVATE ${PROJECT_SOURCE_DIR}/tests/extlib/doctest/doctest/
            )
        target_link_libraries(${TEST_NAME} PUBLIC toml11 toml11_test_utility)
        if(MSVC)
            target_compile_options(${TEST_NAME} PRIVATE /W3)
        else()
            target_compile_options(${TEST_NAME} PRIVATE
                $<$<BOOL:${COMPILER_SUPPORTS_WALL}>:                 -Wall                >
                $<$<BOOL:${COMPILER_SUPPORTS_WEXTRA}>:               -Wextra              >
                $<$<BOOL:${COMPILER_SUPPORTS_WPEDANTIC}>:            -Wpedantic           >
                $<$<BOOL:${COMPILER_SUPPORTS_WSIGN_CONVERSION}>:     -Wsign-conversion    >
                $<$<BOOL:${COMPILER_SUPPORTS_WCONVERSION}>:          -Wconversion         >
                $<$<BOOL:${COMPILER_SUPPORTS_WDUPLICATED_COND}>:     -Wduplicated-cond    >
                $<$<BOOL:${COMPILER_SUPPORTS_WDUPLICATED_BRANCHES}>: -Wduplicated-branches>
                $<$<BOOL:${COMPILER_SUPPORTS_WLOGICAL_OP}>:          -Wlogical-op         >
                $<$<BOOL:${COMPILER_SUPPORTS_WDOUBLE_PROMOTION}>:    -Wdouble-promotion   >
                $<$<BOOL:${COMPILER_SUPPORTS_WRANGE_LOOP_ANALYSIS}>: -Wrange-loop-analysis>
                $<$<BOOL:${COMPILER_SUPPORTS_WUNDEF}>:               -Wundef              >
                $<$<BOOL:${COMPILER_SUPPORTS_WSHADOW}>:              -Wshadow             >
                $<$<BOOL:${TOML11_TEST_WITH_ASAN}>:                  -fsanitize=address   >
                $<$<BOOL:${TOML11_TEST_WITH_UBSAN}>:                 -fsanitize=undefined >
                )
            target_link_options(${TEST_NAME} PRIVATE
                $<$<BOOL:${TOML11_TEST_WITH_ASAN}>:                  -fsanitize=address   >
                $<$<BOOL:${TOML11_TEST_WITH_UBSAN}>:                 -fsanitize=undefined >
                )
        endif()
        add_test(NAME ${TEST_NAME} COMMAND ${TEST_NAME})
    endforeach(TEST_NAME)
endif(BUILD_TESTING)

# =============================================================================
# toml-test encoder/decoder

if(TOML11_BUILD_TOML_TESTS)

    add_executable(toml11_decoder to_json.cpp)
    target_include_directories(toml11_decoder
        PRIVATE ${PROJECT_SOURCE_DIR}/tests/extlib/doctest/doctest/
        PRIVATE ${PROJECT_SOURCE_DIR}/tests/extlib/json/include/
        )
    target_link_libraries(toml11_decoder PRIVATE toml11)
    if(MSVC)
        target_compile_options(${TEST_NAME} PRIVATE /W3)
    else()
        target_compile_options(toml11_decoder PRIVATE
            $<$<BOOL:${COMPILER_SUPPORTS_WALL}>:                 -Wall                >
            $<$<BOOL:${COMPILER_SUPPORTS_WEXTRA}>:               -Wextra              >
            $<$<BOOL:${COMPILER_SUPPORTS_WPEDANTIC}>:            -Wpedantic           >
            $<$<BOOL:${COMPILER_SUPPORTS_WSIGN_CONVERSION}>:     -Wsign-conversion    >
            $<$<BOOL:${COMPILER_SUPPORTS_WCONVERSION}>:          -Wconversion         >
            $<$<BOOL:${COMPILER_SUPPORTS_WDUPLICATED_COND}>:     -Wduplicated-cond    >
            $<$<BOOL:${COMPILER_SUPPORTS_WDUPLICATED_BRANCHES}>: -Wduplicated-branches>
            $<$<BOOL:${COMPILER_SUPPORTS_WLOGICAL_OP}>:          -Wlogical-op         >
            $<$<BOOL:${COMPILER_SUPPORTS_WDOUBLE_PROMOTION}>:    -Wdouble-promotion   >
            $<$<BOOL:${COMPILER_SUPPORTS_WRANGE_LOOP_ANALYSIS}>: -Wrange-loop-analysis>
            $<$<BOOL:${COMPILER_SUPPORTS_WUNDEF}>:               -Wundef              >
            $<$<BOOL:${COMPILER_SUPPORTS_WSHADOW}>:              -Wshadow             >
            $<$<BOOL:${TOML11_TEST_WITH_ASAN}>:                  -fsanitize=address   >
            $<$<BOOL:${TOML11_TEST_WITH_UBSAN}>:                 -fsanitize=undefined >
            )
        target_link_options(toml11_decoder PRIVATE
            $<$<BOOL:${TOML11_TEST_WITH_ASAN}>:                  -fsanitize=address   >
            $<$<BOOL:${TOML11_TEST_WITH_UBSAN}>:                 -fsanitize=undefined >
            )
    endif()

    add_executable(toml11_decoder_v1_1_0 to_json.cpp)
    target_include_directories(toml11_decoder_v1_1_0
        PRIVATE ${PROJECT_SOURCE_DIR}/tests/extlib/doctest/doctest/
        PRIVATE ${PROJECT_SOURCE_DIR}/tests/extlib/json/include/
        )
    target_compile_definitions(toml11_decoder_v1_1_0 PRIVATE -DTOML11_TO_JSON_USE_V1_1_0)
    target_link_libraries(toml11_decoder_v1_1_0 PRIVATE toml11)
    if(MSVC)
        target_compile_options(${TEST_NAME} PRIVATE /W3)
    else()
        target_compile_options(toml11_decoder_v1_1_0 PRIVATE
            $<$<BOOL:${COMPILER_SUPPORTS_WALL}>:                 -Wall                >
            $<$<BOOL:${COMPILER_SUPPORTS_WEXTRA}>:               -Wextra              >
            $<$<BOOL:${COMPILER_SUPPORTS_WPEDANTIC}>:            -Wpedantic           >
            $<$<BOOL:${COMPILER_SUPPORTS_WSIGN_CONVERSION}>:     -Wsign-conversion    >
            $<$<BOOL:${COMPILER_SUPPORTS_WCONVERSION}>:          -Wconversion         >
            $<$<BOOL:${COMPILER_SUPPORTS_WDUPLICATED_COND}>:     -Wduplicated-cond    >
            $<$<BOOL:${COMPILER_SUPPORTS_WDUPLICATED_BRANCHES}>: -Wduplicated-branches>
            $<$<BOOL:${COMPILER_SUPPORTS_WLOGICAL_OP}>:          -Wlogical-op         >
            $<$<BOOL:${COMPILER_SUPPORTS_WDOUBLE_PROMOTION}>:    -Wdouble-promotion   >
            $<$<BOOL:${COMPILER_SUPPORTS_WRANGE_LOOP_ANALYSIS}>: -Wrange-loop-analysis>
            $<$<BOOL:${COMPILER_SUPPORTS_WUNDEF}>:               -Wundef              >
            $<$<BOOL:${COMPILER_SUPPORTS_WSHADOW}>:              -Wshadow             >
            $<$<BOOL:${TOML11_TEST_WITH_ASAN}>:                  -fsanitize=address   >
            $<$<BOOL:${TOML11_TEST_WITH_UBSAN}>:                 -fsanitize=undefined >
            )
        target_link_options(toml11_decoder_v1_1_0 PRIVATE
            $<$<BOOL:${TOML11_TEST_WITH_ASAN}>:                  -fsanitize=address   >
            $<$<BOOL:${TOML11_TEST_WITH_UBSAN}>:                 -fsanitize=undefined >
            )
    endif()

    add_executable(toml11_encoder to_toml.cpp)
    target_include_directories(toml11_encoder
        PRIVATE ${PROJECT_SOURCE_DIR}/tests/extlib/doctest/doctest/
        PRIVATE ${PROJECT_SOURCE_DIR}/tests/extlib/json/include/
        )
    target_link_libraries(toml11_encoder PRIVATE toml11)
    if(MSVC)
        target_compile_options(${TEST_NAME} PRIVATE /W3)
    else()
        target_compile_options(toml11_encoder PRIVATE
            $<$<BOOL:${COMPILER_SUPPORTS_WALL}>:                 -Wall                >
            $<$<BOOL:${COMPILER_SUPPORTS_WEXTRA}>:               -Wextra              >
            $<$<BOOL:${COMPILER_SUPPORTS_WPEDANTIC}>:            -Wpedantic           >
            $<$<BOOL:${COMPILER_SUPPORTS_WSIGN_CONVERSION}>:     -Wsign-conversion    >
            $<$<BOOL:${COMPILER_SUPPORTS_WCONVERSION}>:          -Wconversion         >
            $<$<BOOL:${COMPILER_SUPPORTS_WDUPLICATED_COND}>:     -Wduplicated-cond    >
            $<$<BOOL:${COMPILER_SUPPORTS_WDUPLICATED_BRANCHES}>: -Wduplicated-branches>
            $<$<BOOL:${COMPILER_SUPPORTS_WLOGICAL_OP}>:          -Wlogical-op         >
            $<$<BOOL:${COMPILER_SUPPORTS_WDOUBLE_PROMOTION}>:    -Wdouble-promotion   >
            $<$<BOOL:${COMPILER_SUPPORTS_WRANGE_LOOP_ANALYSIS}>: -Wrange-loop-analysis>
            $<$<BOOL:${COMPILER_SUPPORTS_WUNDEF}>:               -Wundef              >
            $<$<BOOL:${COMPILER_SUPPORTS_WSHADOW}>:              -Wshadow             >
            $<$<BOOL:${TOML11_TEST_WITH_ASAN}>:                  -fsanitize=address   >
            $<$<BOOL:${TOML11_TEST_WITH_UBSAN}>:                 -fsanitize=undefined >
            )
        target_link_options(toml11_encoder PRIVATE
            $<$<BOOL:${TOML11_TEST_WITH_ASAN}>:                  -fsanitize=address   >
            $<$<BOOL:${TOML11_TEST_WITH_UBSAN}>:                 -fsanitize=undefined >
            )
    endif()
endif(TOML11_BUILD_TOML_TESTS)

=== debian/changelog ===
toml11 (4.0.1-1) unstable; urgency=medium

  * New upstream version
  * Standards-Version: 4.7.0 (routine-update)
  * d/patches: Refresh cmake-install.patch, remove allow_tests.patch,
    and add patch to use external header file in tests
  * d/tests/toml: Remove test files that are not needed
  * d/copyright: Update copyright for removed test files
  * d/control: Replace libbost-test-dev with nlohmann-json3-dev and
    doctest-dev in Build-Depends for testing framework
  * d/tests/control: Replace libbost-test-dev with nlohmann-json3-dev
    and doctest-dev in Depends for testing framework and remove git
  * d/rules: Update variable name to build tests, remove undefined option,
    and remove copy for test files that have been removed
  * d/tests/run-unit-test: Update variable name to build tests, remove
    undefined option, and remove git specific option

 -- Lance Lin <lq27267@gmail.com>  Fri, 28 Jun 2024 19:13:50 +0700

toml11 (3.8.1-2) unstable; urgency=medium

  * d/control: Add libboost-test-dev to Build-Depends for running tests
  * d/patches: Refresh and add patch to allow tests to run during build
  * d/tests/toml: Include test files from external source that were being
    cloned during testing
  * d/copyright: Add copyright for included test files in debian/tests/toml
  * d/rules: Additional options for running the tests during build and copy
    test files from debian/tests/toml directory before dh_auto_configure

 -- Lance Lin <lq27267@gmail.com>  Thu, 07 Mar 2024 19:32:29 +0700

## toml11 4.0.3

=== debian/changelog ===
toml11 (4.0.3-1) unstable; urgency=medium

  * New upstream version
  * d/patches: Refresh cmake-install.patch and
    include_doctest_from_external_dependency.patch.
  * d/patches: Add patch to downgrade uninitialized variable error
    to warning.
  * d/rules: Only build tests for amd64.

 -- Lance Lin <lq27267@gmail.com>  Thu, 18 Jul 2024 22:39:35 +0700

=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

ifneq (,$(filter $(DEB_BUILD_ARCH),amd64))
export build_toml_tests=ON
else
export build_toml_tests=OFF
endif

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_CXX_STANDARD=11 \
		-DTOML11_BUILD_TOML_TESTS=${build_toml_tests}

## toml11 4.1.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,11 +1,26 @@
 cmake_minimum_required(VERSION 3.16)
-project(toml11 LANGUAGES CXX VERSION 4.0.0)
 
-include(CMakeDependentOption)
-include(CTest)
+# project_source_dir has not been set yet
+file(STRINGS "${CMAKE_CURRENT_SOURCE_DIR}/include/toml11/version.hpp" TOML11_MAJOR_VERSION_STRING
+    REGEX "#define TOML11_VERSION_MAJOR ([0-9]+)")
+file(STRINGS "${CMAKE_CURRENT_SOURCE_DIR}/include/toml11/version.hpp" TOML11_MINOR_VERSION_STRING
+    REGEX "#define TOML11_VERSION_MINOR ([0-9]+)")
+file(STRINGS "${CMAKE_CURRENT_SOURCE_DIR}/include/toml11/version.hpp" TOML11_PATCH_VERSION_STRING
+    REGEX "#define TOML11_VERSION_PATCH ([0-9]+)")
+
+string(REGEX REPLACE "#define TOML11_VERSION_MAJOR ([0-9]+)" "\\1" TOML11_VERSION_MAJOR "${TOML11_MAJOR_VERSION_STRING}")
+string(REGEX REPLACE "#define TOML11_VERSION_MINOR ([0-9]+)" "\\1" TOML11_VERSION_MINOR "${TOML11_MINOR_VERSION_STRING}")
+string(REGEX REPLACE "#define TOML11_VERSION_PATCH ([0-9]+)" "\\1" TOML11_VERSION_PATCH "${TOML11_PATCH_VERSION_STRING}")
+
+project(toml11 LANGUAGES CXX VERSION "${TOML11_VERSION_MAJOR}.${TOML11_VERSION_MINOR}.${TOML11_VERSION_PATCH}")
+
+include(CTest) # to use ${BUILD_TESTING}
 
 option(TOML11_PRECOMPILE "precompile toml11 library" OFF)
 
+include(CMakeDependentOption)
+cmake_policy(PUSH)
+cmake_policy(SET CMP0127 OLD) # syntax of condition changed in 3.22
 cmake_dependent_option(TOML11_INSTALL "install toml11 library" ON
     "${CMAKE_PROJECT_NAME} STREQUAL ${PROJECT_NAME}" OFF)
 cmake_dependent_option(TOML11_BUILD_EXAMPLES "build toml11 examples" OFF
@@ -14,6 +29,8 @@
     "${CMAKE_PROJECT_NAME} STREQUAL ${PROJECT_NAME}; ${BUILD_TESTING}" OFF)
 cmake_dependent_option(TOML11_BUILD_TOML_TESTS "build toml11 toml-test encoder & decoder" OFF
     "${CMAKE_PROJECT_NAME} STREQUAL ${PROJECT_NAME}" OFF)
+cmake_policy(POP)
+
 cmake_dependent_option(TOML11_TEST_WITH_ASAN  "build toml11 unit tests with asan" OFF
     "${TOML11_BUILD_TESTS}" OFF)
 cmake_dependent_option(TOML11_TEST_WITH_UBSAN "build toml11 unit tests with ubsan" OFF
@@ -23,8 +40,22 @@
     message(FATAL_ERROR "trying to build tests with BOTH asan and ubsan")
 endif()
 
+include(CheckCXXCompilerFlag)
+check_cxx_compiler_flag("-Wall"                 TOML11_COMPILER_SUPPORTS_WALL)
+check_cxx_compiler_flag("-Wextra"               TOML11_COMPILER_SUPPORTS_WEXTRA)
+check_cxx_compiler_flag("-Wpedantic"            TOML11_COMPILER_SUPPORTS_WPEDANTIC)
+check_cxx_compiler_flag("-Werror"               TOML11_COMPILER_SUPPORTS_WERROR)
+check_cxx_compiler_flag("-Wsign-conversion"     TOML11_COMPILER_SUPPORTS_WSIGN_CONVERSION)
+check_cxx_compiler_flag("-Wconversion"          TOML11_COMPILER_SUPPORTS_WCONVERSION)
+check_cxx_compiler_flag("-Wduplicated-cond"     TOML11_COMPILER_SUPPORTS_WDUPLICATED_COND)
+check_cxx_compiler_flag("-Wduplicated-branches" TOML11_COMPILER_SUPPORTS_WDUPLICATED_BRANCHES)
+check_cxx_compiler_flag("-Wlogical-op"          TOML11_COMPILER_SUPPORTS_WLOGICAL_OP)
+check_cxx_compiler_flag("-Wdouble-promotion"    TOML11_COMPILER_SUPPORTS_WDOUBLE_PROMOTION)
+check_cxx_compiler_flag("-Wrange-loop-analysis" TOML11_COMPILER_SUPPORTS_WRANGE_LOOP_ANALYSIS)
+check_cxx_compiler_flag("-Wundef"               TOML11_COMPILER_SUPPORTS_WUNDEF)
+check_cxx_compiler_flag("-Wshadow"              TOML11_COMPILER_SUPPORTS_WSHADOW)
+
 include(GNUInstallDirs)
-
 set(TOML11_INSTALL_CMAKE_DIR   ${CMAKE_INSTALL_LIBDIR}/cmake/toml11)
 set(TOML11_INSTALL_INCLUDE_DIR ${CMAKE_INSTALL_INCLUDEDIR})
 set(TOML11_CONFIG_DIR          ${CMAKE_CURRENT_BINARY_DIR}/cmake)

=== tests/CMakeLists.txt ===
set(TOML11_TEST_NAMES
    test_comments
    test_datetime
    test_error_message
    test_find
    test_find_or
    test_format_integer
    test_format_floating
    test_format_table
    test_get
    test_get_or
    test_location
    test_literal
    test_parse_null
    test_parse_boolean
    test_parse_integer
    test_parse_floating
    test_parse_string
    test_parse_datetime
    test_parse_array
    test_parse_inline_table
    test_parse_table_keys
    test_parse_table
    test_result
    test_scanner
    test_serialize
    test_syntax_boolean
    test_syntax_integer
    test_syntax_floating
    test_syntax_string
    test_syntax_datetime
    test_syntax_key
    test_syntax_comment
    test_spec
    test_storage
    test_traits
    test_types
    test_utility
    test_user_defined_conversion
    test_value
    test_visit
    )

if(BUILD_TESTING)
    add_library(toml11_test_utility STATIC utility.cpp)
    target_include_directories(toml11_test_utility
        PRIVATE ${PROJECT_SOURCE_DIR}/tests/extlib/doctest/doctest/
        )
    target_link_libraries(toml11_test_utility PUBLIC toml11)

    foreach(TEST_NAME ${TOML11_TEST_NAMES})
        add_executable(${TEST_NAME} ${TEST_NAME}.cpp)
        target_include_directories(${TEST_NAME}
            PRIVATE ${PROJECT_SOURCE_DIR}/tests/extlib/doctest/doctest/
            )
        target_link_libraries(${TEST_NAME} PUBLIC toml11 toml11_test_utility)
        if(MSVC)
            target_compile_options(${TEST_NAME} PRIVATE /W4 /WX)
        else()
            target_compile_options(${TEST_NAME} PRIVATE
                $<$<BOOL:${TOML11_COMPILER_SUPPORTS_WALL}>:                 -Wall                >
                $<$<BOOL:${TOML11_COMPILER_SUPPORTS_WEXTRA}>:               -Wextra              >
                $<$<BOOL:${TOML11_COMPILER_SUPPORTS_WPEDANTIC}>:            -Wpedantic           >
                $<$<BOOL:${TOML11_COMPILER_SUPPORTS_WERROR}>:               -Werror              >
                $<$<BOOL:${TOML11_COMPILER_SUPPORTS_WSIGN_CONVERSION}>:     -Wsign-conversion    >
                $<$<BOOL:${TOML11_COMPILER_SUPPORTS_WCONVERSION}>:          -Wconversion         >
                $<$<BOOL:${TOML11_COMPILER_SUPPORTS_WDUPLICATED_COND}>:     -Wduplicated-cond    >
                $<$<BOOL:${TOML11_COMPILER_SUPPORTS_WDUPLICATED_BRANCHES}>: -Wduplicated-branches>
                $<$<BOOL:${TOML11_COMPILER_SUPPORTS_WLOGICAL_OP}>:          -Wlogical-op         >
                $<$<BOOL:${TOML11_COMPILER_SUPPORTS_WDOUBLE_PROMOTION}>:    -Wdouble-promotion   >
                $<$<BOOL:${TOML11_COMPILER_SUPPORTS_WRANGE_LOOP_ANALYSIS}>: -Wrange-loop-analysis>
                $<$<BOOL:${TOML11_COMPILER_SUPPORTS_WUNDEF}>:               -Wundef              >
                $<$<BOOL:${TOML11_COMPILER_SUPPORTS_WSHADOW}>:              -Wshadow             >
                $<$<BOOL:${TOML11_TEST_WITH_ASAN}>:  -fsanitize=address   >
                $<$<BOOL:${TOML11_TEST_WITH_UBSAN}>: -fsanitize=undefined >
                )
            target_link_options(${TEST_NAME} PRIVATE
                $<$<BOOL:${TOML11_TEST_WITH_ASAN}>:  -fsanitize=address   >
                $<$<BOOL:${TOML11_TEST_WITH_UBSAN}>: -fsanitize=undefined >
                )
        endif()
        add_test(NAME ${TEST_NAME} COMMAND ${TEST_NAME})
    endforeach(TEST_NAME)
endif(BUILD_TESTING)

# =============================================================================
# toml-test encoder/decoder

if(TOML11_BUILD_TOML_TESTS)

    add_executable(toml11_decoder to_json.cpp)
    target_include_directories(toml11_decoder
        PRIVATE ${PROJECT_SOURCE_DIR}/tests/extlib/doctest/doctest/
        PRIVATE ${PROJECT_SOURCE_DIR}/tests/extlib/json/include/
        )
    target_link_libraries(toml11_decoder PRIVATE toml11)
    if(MSVC)
        target_compile_options(${TEST_NAME} PRIVATE /W4 /WX)
    else()
        target_compile_options(toml11_decoder PRIVATE
            $<$<BOOL:${TOML11_COMPILER_SUPPORTS_WALL}>:                 -Wall                >
            $<$<BOOL:${TOML11_COMPILER_SUPPORTS_WEXTRA}>:               -Wextra              >
            $<$<BOOL:${TOML11_COMPILER_SUPPORTS_WPEDANTIC}>:            -Wpedantic           >
            $<$<BOOL:${TOML11_COMPILER_SUPPORTS_WSIGN_CONVERSION}>:     -Wsign-conversion    >
            $<$<BOOL:${TOML11_COMPILER_SUPPORTS_WCONVERSION}>:          -Wconversion         >
            $<$<BOOL:${TOML11_COMPILER_SUPPORTS_WDUPLICATED_COND}>:     -Wduplicated-cond    >
            $<$<BOOL:${TOML11_COMPILER_SUPPORTS_WDUPLICATED_BRANCHES}>: -Wduplicated-branches>
            $<$<BOOL:${TOML11_COMPILER_SUPPORTS_WLOGICAL_OP}>:          -Wlogical-op         >
            $<$<BOOL:${TOML11_COMPILER_SUPPORTS_WDOUBLE_PROMOTION}>:    -Wdouble-promotion   >
            $<$<BOOL:${TOML11_COMPILER_SUPPORTS_WRANGE_LOOP_ANALYSIS}>: -Wrange-loop-analysis>
            $<$<BOOL:${TOML11_COMPILER_SUPPORTS_WUNDEF}>:               -Wundef              >
            $<$<BOOL:${TOML11_COMPILER_SUPPORTS_WSHADOW}>:              -Wshadow             >
            $<$<BOOL:${TOML11_TEST_WITH_ASAN}>:  -fsanitize=address   >
            $<$<BOOL:${TOML11_TEST_WITH_UBSAN}>: -fsanitize=undefined >
            )
        target_link_options(toml11_decoder PRIVATE
            $<$<BOOL:${TOML11_TEST_WITH_ASAN}>:  -fsanitize=address   >
            $<$<BOOL:${TOML11_TEST_WITH_UBSAN}>: -fsanitize=undefined >
            )
    endif()

    add_executable(toml11_decoder_v1_1_0 to_json.cpp)
    target_include_directories(toml11_decoder_v1_1_0
        PRIVATE ${PROJECT_SOURCE_DIR}/tests/extlib/doctest/doctest/
        PRIVATE ${PROJECT_SOURCE_DIR}/tests/extlib/json/include/
        )
    target_compile_definitions(toml11_decoder_v1_1_0 PRIVATE -DTOML11_TO_JSON_USE_V1_1_0)
    target_link_libraries(toml11_decoder_v1_1_0 PRIVATE toml11)
    if(MSVC)
        target_compile_options(${TEST_NAME} PRIVATE /W4 /WX)
    else()
        target_compile_options(toml11_decoder_v1_1_0 PRIVATE
            $<$<BOOL:${COMPILER_SUPPORTS_WALL}>:                 -Wall                >
            $<$<BOOL:${COMPILER_SUPPORTS_WEXTRA}>:               -Wextra              >
            $<$<BOOL:${COMPILER_SUPPORTS_WPEDANTIC}>:            -Wpedantic           >
            $<$<BOOL:${COMPILER_SUPPORTS_WSIGN_CONVERSION}>:     -Wsign-conversion    >
            $<$<BOOL:${COMPILER_SUPPORTS_WCONVERSION}>:          -Wconversion         >
            $<$<BOOL:${COMPILER_SUPPORTS_WDUPLICATED_COND}>:     -Wduplicated-cond    >
            $<$<BOOL:${COMPILER_SUPPORTS_WDUPLICATED_BRANCHES}>: -Wduplicated-branches>
            $<$<BOOL:${COMPILER_SUPPORTS_WLOGICAL_OP}>:          -Wlogical-op         >
            $<$<BOOL:${COMPILER_SUPPORTS_WDOUBLE_PROMOTION}>:    -Wdouble-promotion   >
            $<$<BOOL:${COMPILER_SUPPORTS_WRANGE_LOOP_ANALYSIS}>: -Wrange-loop-analysis>
            $<$<BOOL:${COMPILER_SUPPORTS_WUNDEF}>:               -Wundef              >
            $<$<BOOL:${COMPILER_SUPPORTS_WSHADOW}>:              -Wshadow             >
            $<$<BOOL:${TOML11_TEST_WITH_ASAN}>:                  -fsanitize=address   >
            $<$<BOOL:${TOML11_TEST_WITH_UBSAN}>:                 -fsanitize=undefined >
            )
        target_link_options(toml11_decoder_v1_1_0 PRIVATE
            $<$<BOOL:${TOML11_TEST_WITH_ASAN}>:                  -fsanitize=address   >
            $<$<BOOL:${TOML11_TEST_WITH_UBSAN}>:                 -fsanitize=undefined >
            )
    endif()

    add_executable(toml11_encoder to_toml.cpp)
    target_include_directories(toml11_encoder
        PRIVATE ${PROJECT_SOURCE_DIR}/tests/extlib/doctest/doctest/
        PRIVATE ${PROJECT_SOURCE_DIR}/tests/extlib/json/include/
        )
    target_link_libraries(toml11_encoder PRIVATE toml11)
    if(MSVC)
        target_compile_options(${TEST_NAME} PRIVATE /W4 /WX)
    else()
        target_compile_options(toml11_encoder PRIVATE
            $<$<BOOL:${TOML11_COMPILER_SUPPORTS_WALL}>:                 -Wall                >
            $<$<BOOL:${TOML11_COMPILER_SUPPORTS_WEXTRA}>:               -Wextra              >
            $<$<BOOL:${TOML11_COMPILER_SUPPORTS_WPEDANTIC}>:            -Wpedantic           >
            $<$<BOOL:${TOML11_COMPILER_SUPPORTS_WSIGN_CONVERSION}>:     -Wsign-conversion    >
            $<$<BOOL:${TOML11_COMPILER_SUPPORTS_WCONVERSION}>:          -Wconversion         >
            $<$<BOOL:${TOML11_COMPILER_SUPPORTS_WDUPLICATED_COND}>:     -Wduplicated-cond    >
            $<$<BOOL:${TOML11_COMPILER_SUPPORTS_WDUPLICATED_BRANCHES}>: -Wduplicated-branches>
            $<$<BOOL:${TOML11_COMPILER_SUPPORTS_WLOGICAL_OP}>:          -Wlogical-op         >
            $<$<BOOL:${TOML11_COMPILER_SUPPORTS_WDOUBLE_PROMOTION}>:    -Wdouble-promotion   >
            $<$<BOOL:${TOML11_COMPILER_SUPPORTS_WRANGE_LOOP_ANALYSIS}>: -Wrange-loop-analysis>
            $<$<BOOL:${TOML11_COMPILER_SUPPORTS_WUNDEF}>:               -Wundef              >
            $<$<BOOL:${TOML11_COMPILER_SUPPORTS_WSHADOW}>:              -Wshadow             >
            $<$<BOOL:${TOML11_TEST_WITH_ASAN}>:  -fsanitize=address   >
            $<$<BOOL:${TOML11_TEST_WITH_UBSAN}>: -fsanitize=undefined >
            )
        target_link_options(toml11_encoder PRIVATE
            $<$<BOOL:${TOML11_TEST_WITH_ASAN}>:  -fsanitize=address   >
            $<$<BOOL:${TOML11_TEST_WITH_UBSAN}>: -fsanitize=undefined >
            )
    endif()
endif(TOML11_BUILD_TOML_TESTS)

=== examples/u8string/CMakeLists.txt ===
add_executable(u8string u8string.cpp)
target_link_libraries(u8string PRIVATE toml11::toml11)
target_compile_features(u8string PRIVATE cxx_std_20)
set_target_properties(u8string PROPERTIES
    RUNTIME_OUTPUT_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}")

=== debian/changelog ===
toml11 (4.1.0-1) unstable; urgency=medium

  * New upstream version
  * d/rules: Build tests for all architectures.
  * d/patches: Add patch to manually cast the file size to std::streamsize
    for 32-bit architectures.
  * d/patches: Extend cmake-install.patch to generate arch-independent
    cmake config files.

 -- Lance Lin <lq27267@gmail.com>  Mon, 05 Aug 2024 22:35:37 +0700

## toml11 4.2.0

=== debian/changelog ===
toml11 (4.2.0-1) unstable; urgency=medium

  * New upstream version
  * d/patches: Remove patch applied upstream.

 -- Lance Lin <lq27267@gmail.com>  Thu, 22 Aug 2024 21:31:59 +0700

## toml11 4.3.0

=== debian/changelog ===
toml11 (4.3.0-1) unstable; urgency=medium

  * New upstream version
  * d/patches: Refresh patches.
  * d/copyright: Update copyright year for debian files.

 -- Lance Lin <lq27267@gmail.com>  Fri, 17 Jan 2025 21:45:21 +0700

## toml11 4.4.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -17,10 +17,13 @@
 include(CTest) # to use ${BUILD_TESTING}
 
 option(TOML11_PRECOMPILE "precompile toml11 library" OFF)
+option(TOML11_ENABLE_ACCESS_CHECK "enable access check feature (beta)" OFF)
 
 include(CMakeDependentOption)
 cmake_policy(PUSH)
+if(POLICY CMP0127)
 cmake_policy(SET CMP0127 OLD) # syntax of condition changed in 3.22
+endif()
 cmake_dependent_option(TOML11_INSTALL "install toml11 library" ON
     "${CMAKE_PROJECT_NAME} STREQUAL ${PROJECT_NAME}" OFF)
 cmake_dependent_option(TOML11_BUILD_EXAMPLES "build toml11 examples" OFF

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -90,7 +90,10 @@
         types.cpp
         value_t.cpp
         )
-    target_compile_definitions(toml11 PUBLIC -DTOML11_COMPILE_SOURCES)
+    target_compile_definitions(toml11 PUBLIC
+        -DTOML11_COMPILE_SOURCES
+        $<$<BOOL:${TOML11_ENABLE_ACCESS_CHECK}>: -DTOML11_ENABLE_ACCESS_CHECK>
+        )
     target_include_directories(toml11 PUBLIC
         $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
         $<INSTALL_INTERFACE:include>
@@ -99,6 +102,7 @@
     # required options to use toml11 with MSVC
     if(MSVC)
         target_compile_options(toml11 PUBLIC "/utf-8")
+        target_compile_options(toml11 PRIVATE "/W4" "/WX")
         if(MSVC_VERSION LESS 1910)
             message(STATUS "MSVC < 1910. DEFINE_CONVERSION_NON_INTRUSIVE is disabled")
             target_compile_definitions(toml11 PUBLIC -DTOML11_WITHOUT_DEFINE_NON_INTRUSIVE)
@@ -107,9 +111,28 @@
         else() # MSVC 2019
             target_compile_options(toml11 PUBLIC "/Zc:preprocessor")
         endif()
+    else()
+        target_compile_options(toml11 PRIVATE
+            $<$<BOOL:${TOML11_COMPILER_SUPPORTS_WALL}>:                 -Wall                >
+            $<$<BOOL:${TOML11_COMPILER_SUPPORTS_WEXTRA}>:               -Wextra              >
+            $<$<BOOL:${TOML11_COMPILER_SUPPORTS_WPEDANTIC}>:            -Wpedantic           >
+            $<$<BOOL:${TOML11_COMPILER_SUPPORTS_WERROR}>:               -Werror              >
+            $<$<BOOL:${TOML11_COMPILER_SUPPORTS_WSIGN_CONVERSION}>:     -Wsign-conversion    >
+            $<$<BOOL:${TOML11_COMPILER_SUPPORTS_WCONVERSION}>:          -Wconversion         >
+            $<$<BOOL:${TOML11_COMPILER_SUPPORTS_WDUPLICATED_COND}>:     -Wduplicated-cond    >
+            $<$<BOOL:${TOML11_COMPILER_SUPPORTS_WDUPLICATED_BRANCHES}>: -Wduplicated-branches>
+            $<$<BOOL:${TOML11_COMPILER_SUPPORTS_WLOGICAL_OP}>:          -Wlogical-op         >
+            $<$<BOOL:${TOML11_COMPILER_SUPPORTS_WDOUBLE_PROMOTION}>:    -Wdouble-promotion   >
+            $<$<BOOL:${TOML11_COMPILER_SUPPORTS_WRANGE_LOOP_ANALYSIS}>: -Wrange-loop-analysis>
+            $<$<BOOL:${TOML11_COMPILER_SUPPORTS_WUNDEF}>:               -Wundef              >
+            $<$<BOOL:${TOML11_COMPILER_SUPPORTS_WSHADOW}>:              -Wshadow             >
+        )
     endif()
 else()
     add_library(toml11 INTERFACE)
+    target_compile_definitions(toml11 INTERFACE
+        $<$<BOOL:${TOML11_ENABLE_ACCESS_CHECK}>: -DTOML11_ENABLE_ACCESS_CHECK>
+        )
     target_include_directories(toml11 INTERFACE
         $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
         $<INSTALL_INTERFACE:include>

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -21,6 +21,7 @@
     test_parse_inline_table
     test_parse_table_keys
     test_parse_table
+    test_parse
     test_result
     test_scanner
     test_serialize
@@ -38,6 +39,7 @@
     test_utility
     test_user_defined_conversion
     test_value
+    test_accessed
     test_visit
     )

=== examples/boost_container/CMakeLists.txt ===
find_package(Boost 1.81.0)

if(Boost_FOUND)
    add_executable(container container.cpp)
    target_link_libraries(container PRIVATE toml11::toml11 Boost::boost)
    set_target_properties(container PROPERTIES
        RUNTIME_OUTPUT_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}")
endif()

=== examples/boost_multiprecision/CMakeLists.txt ===
find_package(Boost 1.67.0)

if(Boost_FOUND)
    add_executable(multiprecision multiprecision.cpp)
    target_link_libraries(multiprecision PRIVATE toml11::toml11 Boost::boost)
    set_target_properties(multiprecision PROPERTIES
        RUNTIME_OUTPUT_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}")
endif()

=== examples/parse_file/CMakeLists.txt ===
add_executable(spec_example spec_example.cpp)
target_link_libraries(spec_example PRIVATE toml11::toml11)
set_target_properties(spec_example PROPERTIES
    RUNTIME_OUTPUT_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}")

add_executable(key_example key_example.cpp)
target_link_libraries(key_example PRIVATE toml11::toml11)
set_target_properties(key_example PROPERTIES
    RUNTIME_OUTPUT_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}")

add_executable(array_example array_example.cpp)
target_link_libraries(array_example PRIVATE toml11::toml11)
set_target_properties(array_example PROPERTIES
    RUNTIME_OUTPUT_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}")

add_executable(array_of_tables_example array_of_tables_example.cpp)
target_link_libraries(array_of_tables_example PRIVATE toml11::toml11)
set_target_properties(array_of_tables_example PROPERTIES
    RUNTIME_OUTPUT_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}")

=== examples/reflect/CMakeLists.txt ===
include(FetchContent)

FetchContent_Declare(
  boost_ext_reflect
  GIT_REPOSITORY https://github.com/boost-ext/reflect
  GIT_SHALLOW ON  # Download the branch without its history
  GIT_TAG        v1.1.1
)
FetchContent_MakeAvailable(boost_ext_reflect)

add_executable(reflect reflect.cpp)
target_link_libraries(reflect PRIVATE toml11::toml11)
target_include_directories(reflect PRIVATE
    ${boost_ext_reflect_SOURCE_DIR}
    )
target_compile_features(reflect PRIVATE cxx_std_20)
set_target_properties(reflect PROPERTIES
    RUNTIME_OUTPUT_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}")

=== examples/unicode/CMakeLists.txt ===
include(FetchContent)

FetchContent_Declare(uni-algo
  GIT_REPOSITORY https://github.com/uni-algo/uni-algo.git
  GIT_SHALLOW ON  # Download the branch without its history
  GIT_TAG v1.0.0) # The version you want to download

# Be aware that FetchContent_MakeAvailable requires CMake 3.14 or higher
FetchContent_MakeAvailable(uni-algo)

add_executable(canonicalize canonicalize.cpp)
target_link_libraries(canonicalize PRIVATE toml11::toml11 uni-algo::uni-algo)
set_target_properties(canonicalize PROPERTIES
    RUNTIME_OUTPUT_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}")

=== debian/changelog ===
toml11 (4.4.0-1) unstable; urgency=medium

  * New upstream version
  * d/patches: Refresh patches.

 -- Lance Lin <lq27267@gmail.com>  Thu, 20 Feb 2025 20:17:25 +0700

=== debian/control ===
Source: toml11
Section: libdevel
Priority: optional
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Lance Lin <lq27267@gmail.com>
Build-Depends: cmake, debhelper-compat (= 13), nlohmann-json3-dev, doctest-dev
Standards-Version: 4.7.0
Vcs-Browser: https://salsa.debian.org/med-team/toml11
Vcs-Git: https://salsa.debian.org/med-team/toml11.git
Homepage: https://github.com/ToruNiina/toml11
Rules-Requires-Root: no

Package: libtoml11-dev
Architecture: all
Depends: ${misc:Depends}
Multi-Arch: foreign
Description: TOML parser/encoder
 toml11:
 It is compatible to the latest version of TOML v1.0.0.
 It is one of the most TOML standard compliant libraries, tested with the
 language agnostic test suite for TOML parsers by BurntSushi.
 It shows highly informative error messages. You can see the error messages
 about invalid files at CircleCI.
 It has configurable container. You can use any random-access containers
 and key-value maps as backend containers.
 It optionally preserves comments without any overhead.
 It has configurable serializer that supports comments, inline tables,
 literal strings and multiline strings.
 It supports user-defined type conversion from/into toml values.
 It correctly handles UTF-8 sequences, with or without BOM,
 both on posix and Windows.
 .
 This package contains the development header files.

=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_CXX_STANDARD=11 \
		-DTOML11_BUILD_TOML_TESTS=ON

=== debian/tests/control ===
Tests: run-unit-test
Depends: @, cmake, build-essential, nlohmann-json3-dev, doctest-dev
Restrictions: allow-stderr
